package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.OrderInvoice;
import com.izouma.awesomeadmin.service.OrderInvoiceService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/orderInvoice")
@RequiresAuthentication
public class OrderInvoiceController {

    @Autowired
    private OrderInvoiceService orderInvoiceService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(OrderInvoice record) {
        List<OrderInvoice> pp = orderInvoiceService.getOrderInvoiceList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getOrderInvoice", method = RequestMethod.GET)
    @ResponseBody
    public Result getOrderInvoice(@RequestParam(required = false, value = "id") String id) {
        OrderInvoice data = orderInvoiceService.getOrderInvoiceById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(OrderInvoice record) {
        OrderInvoice data = orderInvoiceService.getOrderInvoice(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, OrderInvoice record) {
        Map<String, Object> result = new HashMap<>();

        List<OrderInvoice> pp =orderInvoiceService.getOrderInvoiceByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(OrderInvoice record) {
        boolean num = orderInvoiceService.createOrderInvoice(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateOrderInvoice(OrderInvoice record) {
        boolean num = orderInvoiceService.updateOrderInvoice(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteOrderInvoice(@RequestParam(required = true, value = "id") String id) {

        boolean num = orderInvoiceService.deleteOrderInvoice(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, OrderInvoice record) throws Exception {

    List<OrderInvoice> orderInvoices = orderInvoiceService.getOrderInvoiceList(record);


        String sheetName = "order_invoice";
        String titleName = "订单发票数据表";
        String fileName = "订单发票表";
        int columnNumber = 13;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "用户" ,   "订单" ,   "店铺" ,   "发票号" ,   "发票" ,   "备注" ,   "类型"  };
        String[][] dataList = new String[orderInvoices.size()][13];

        for (int i = 0; i < orderInvoices.size(); i++) {

                        dataList[i][0] = String.valueOf(orderInvoices.get(i).getId());
                        dataList[i][1] = String.valueOf(orderInvoices.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(orderInvoices.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(orderInvoices.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(orderInvoices.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(orderInvoices.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(orderInvoices.get(i).getUserId());
                        dataList[i][7] = String.valueOf(orderInvoices.get(i).getOrderId());
                        dataList[i][8] = String.valueOf(orderInvoices.get(i).getStoreId());
                        dataList[i][9] = String.valueOf(orderInvoices.get(i).getInvoiceNo());
                        dataList[i][10] = String.valueOf(orderInvoices.get(i).getImage());
                        dataList[i][11] = String.valueOf(orderInvoices.get(i).getRemark());
                        dataList[i][12] = String.valueOf(orderInvoices.get(i).getTypeFlag());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

